import org.red5.logging.Red5LoggerFactory;
import org.red5.server.api.scope.IScope;
import org.red5.server.api.stream.IStreamFilenameGenerator;
import org.red5.server.util.ScopeUtils;
import org.slf4j.Logger;

import dto.RoomItem;


public class StreamNameGenerator implements IStreamFilenameGenerator {

	final Logger logger = Red5LoggerFactory.getLogger(this.getClass());
    
	public StreamNameGenerator() {
		// TODO Auto-generated constructor stub
	}

	private String getStreamDirectory(IScope scope) 
	{
        final StringBuilder result = new StringBuilder();
        final IScope app = ScopeUtils.findApplication(scope);
        final String prefix = "streams/";
        while (scope != null && scope != app) {
                result.insert(0, scope.getName() + "/");
                scope = scope.getParent();
        }
        if (result.length() == 0) {
                return prefix;
        } else {
                //result.insert(0, prefix).append('/');
                return result.toString();
        }
	}
	
	@Override
	public String generateFilename(IScope scope, String name, GenerationType type) 
	{
		return generateFilename(scope, name, null, type);
	}

	@Override
	public String generateFilename(IScope scope, String name, String ext, GenerationType type) 
	{
		String filename;
		
		String pathRec = "webapps/" + ScopeUtils.findApplication(scope).getName() + "/streams/" +
						getStreamDirectory(scope) + name;
		String pathPlay = "webapps/" + ScopeUtils.findApplication(scope).getName() + "/" +
						getStreamDirectory(scope) + name;
		
        if (type == GenerationType.RECORD)
            filename = pathRec + RoomItem.now(RoomItem.dateFile);
        else
            filename = pathPlay;
        
        if (ext != null)
            filename += ext;
        
        logger.info("	Make a file:" + filename);
        return filename;
	}

	@Override
	public boolean resolvesToAbsolutePath() {
		// TODO Auto-generated method stub
		return true;
	}
}
